/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#ifndef Blank_h
#define Blank_h


#include "Primitives.h"
#include "something.h"   /// to compose thing in other package

#include "otherthing package.h"   /// to reference thing in other package




#include "package.h"
namespace hxa7241 { namespace package {
	using namespace hxa7241::primitives;
	using whatever::something;    /// to use things in other packages
	using whatever::otherthing;


/**
 * an empty class to show standard code structure.<br/><br/>
 *
 * (class comments are based on java conventions.<br/>
 * the first line of the class comment summarises the class in one short line
 * ending with a '.'. it is compulsory.<br/>
 * the following lines of the class comment up to the first '@' section are general
 * commentary for users of the class. they are compulsory.)<br/><br/>
 *
 * the 'standard object services' section contains basic methods all classes must
 * treat: constructor and destructor must be declared and defined, copy constructor
 * and copy assignment must be declared and defined or declared private and not
 * defined. also for containing contructor variants, assignment variants, and
 * conversion operators.<br/><br/>
 *
 * the 'commands' section contains methods that change object state - that is non
 * const methods - that also do not provide values to callers.<br/><br/>
 *
 * the 'queries' section contains methods that do not change object state - that is
 * const methods - that do provide values to callers.<br/><br/>
 *
 * the 'implementation' section contains misc background methods called by methods
 * in other sections.
 *
 * @see
 * the 'see' comment section refers to other related classes or code. this is
 * optional.
 *
 * @implementation
 * the 'implementation' comment section contains general commentary for (re-)
 * implementors and derivers of the class. this is optional.
 *
 * @invariants
 * the 'invariants' comment section lists conditions that shall/must obtain for
 * each of the fields in the class. this is optional.
 */
class Blank
{
/// standard object services -----------------------------------------------------------------------
public:
	         Blank();

	virtual ~Blank();
	         Blank( const Blank& );
	Blank& operator=( const Blank& );


/// commands ---------------------------------------------------------------------------------------
public:


/// queries ----------------------------------------------------------------------------------------
public:


/// serialization ----------------------------------------------------------------------------------
public:


/// implementation ---------------------------------------------------------------------------------
protected:


/// fields -----------------------------------------------------------------------------------------
private:

};


}}




#endif//Blank_h
