/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#ifndef LightStream_h
#define LightStream_h


#include "Primitives.h"
#include "UnitVector3f.h"
#include "Light.h"
#include <iosfwd>




#include "perceptuum2_interaction.h"
namespace perceptuum2 { namespace interaction {
	using namespace hxa7241::primitives;
	using hxa7241::graphics::UnitVector3f;


class LightStream
{
/// standard object services -----------------------------------------------------------------------
public:
	         LightStream();
	         LightStream( const UnitVector3f& direction, const Light& light );

	        ~LightStream();
	         LightStream( const LightStream& );
	LightStream& operator=( const LightStream& );

	friend  std::ostream& operator<<( std::ostream&, const LightStream& );


/// commands ---------------------------------------------------------------------------------------
public:
	         void  set( const UnitVector3f& direction, const Light& light );


/// fields -----------------------------------------------------------------------------------------
public:
	UnitVector3f direction_m;
	Light        light_m;
};








std::ostream& operator<<( std::ostream&, const LightStream& );




/// INLINES ///

/// standard object services -----------------------------------------------------------------------
inline
LightStream::LightStream()
 :	direction_m(),
 	light_m()
{
}


inline
LightStream::~LightStream()
{
}


}}




#endif//LightStream_h
