/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#ifndef Medium_h
#define Medium_h


#include "Primitives.h"

#include "perceptuum2_interaction.h"
#include "hxa7241_graphics.h"
#include "hxa7241_utility.h"




#include "perceptuum2_interaction.h"
namespace perceptuum2 { namespace interaction {
	using namespace hxa7241::primitives;
	using perceptuum2::modelling::ObjectRenderableId;
	using hxa7241::graphics::Vector3f;
	using hxa7241::utility::Float01;


class Medium
{
/// standard object services -----------------------------------------------------------------------
public:
	         Medium( const ObjectRenderableId& );

	virtual ~Medium();
	         Medium( const Medium& );
	Medium& operator=( const Medium& );


/// commands ---------------------------------------------------------------------------------------
public:


/// queries ----------------------------------------------------------------------------------------
public:
	/** @return is kept alive */
	virtual bool  getParticipationRoulette( Float01         stochastic,
	                                        const Vector3f& pos1,
	                                        const Vector3f& pos2,
	                                        Light&          inOut )                           const;
	virtual void  getParticipationScaling( const Vector3f& pos1,
	                                       const Vector3f& pos2,
	                                       Light&          scaling )                          const;
	virtual void  participateLight( const Vector3f& pos1,
	                                const Vector3f& pos2,
	                                Light&          inOut )                                   const;


/// fields -----------------------------------------------------------------------------------------
private:
	ObjectRenderableId object_m;
};


}}




#endif//Medium_h
