/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#ifndef RenderingTime_h
#define RenderingTime_h


#include "Primitives.h"




#include "perceptuum2_transport.h"
namespace perceptuum2 { namespace transport {
	using namespace hxa7241::primitives;


class RenderingTime
{
/// standard object services -----------------------------------------------------------------------
public:
	         RenderingTime();
	         RenderingTime( float begin, float end );

	        ~RenderingTime();
	         RenderingTime( const RenderingTime& );
	RenderingTime& operator=( const RenderingTime& );


/// commands ---------------------------------------------------------------------------------------
public:
	        void  set( float begin, float end );
	        void  setTimePoint( float fp01 );


/// queries ----------------------------------------------------------------------------------------
public:
	        float getTime() const;


/// fields -----------------------------------------------------------------------------------------
private:
	float begin_m;
	float end_m;

	float current_m;
};


}}




#endif//RenderingTime_h
