/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#ifndef InfoDialog_h
#define InfoDialog_h


#include "Primitives.h"
#include "Win32Dialog.h"
#include <vector>
#include <string>




#include "perceptuum2_platform_ui.h"
namespace perceptuum2 { namespace platform_ui {
	using namespace hxa7241::primitives;
	using hxa7241::win32::Win32Dialog;
	using std::vector;
	using std::string;


class InfoDialog
	: protected Win32Dialog
{
/// standard object services -----------------------------------------------------------------------
public:
	         InfoDialog( HINSTANCE hInstance, HWND hWndParent );

	virtual ~InfoDialog();
private:
	         InfoDialog( const InfoDialog& );
	InfoDialog& operator=( const InfoDialog& );


/// commands ---------------------------------------------------------------------------------------
public:
	        int   run( vector<string>* pNames, vector<string>* pSummaries );
	virtual int   run();


/// overrides --------------------------------------------------------------------------------------
protected:
	virtual int   getDialogResourceId() const;
public:
	virtual bool  dialogProc( HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam );


/// implementation ---------------------------------------------------------------------------------
private:
	static  HWND  createTabs( HWND hWndDlg, HINSTANCE hInstance, const vector<string>& names );
	static  bool  createTextDisplays( HINSTANCE hInstance, HWND hWndTabs, HFONT,
	                                  const vector<string>& summaries, vector<HWND>& hWndTexts );


/// fields -----------------------------------------------------------------------------------------
private:
	HWND         hWndTabs_m;
	vector<HWND> hWndTexts_m;
	HFONT        hFont_m;

	const vector<string>* pNames_m;
	const vector<string>* pSummaries_m;
};


}}




#endif//InfoDialog_h
