/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#include "Float16.h"   /// own header is included last


using namespace hxa7241::utility;




/// statics ----------------------------------------------------------------------------------------
word Float16::fromFloat
(
	const float fp
)
{
	const dword floatBits = *(reinterpret_cast<const dword*>( &fp ));

	/// truncate mantissa ls bits
	return word( floatBits >> 16 );
}


float Float16::toFloat
(
	const word w
)
{
	/// shift up, and repeat mantissa (including implicit 1) into ls bits
	dword floatBits = (w << 16);
	floatBits |= ((w & 0xFF) << 8);
	floatBits |= (w & 0xFF);
	floatBits |= 0x8080;
//	const dword floatBits = (w << 16) | ((w & 0xFF) << 8) | (w & 0xFF) | 0x8080;   /// a few more instructions

	return *(reinterpret_cast<const float*>( &floatBits ));
}
